import Button from "@/components/Low/Button";
import axios from "axios";
import { capitalize, uniqBy } from "lodash";
import { useEffect, useState } from "react";
import { toast } from "react-toastify";
import { useFilePicker } from "use-file-picker";
import readXlsxFile from "read-excel-file";
import Modal from "@/components/Modal";
import { BsQuestionCircleFill } from "react-icons/bs";
import { PermissionType } from "@/interfaces/permissions";
import moment from "moment";
import { checkAccess, getTypesOfUser } from "@/utils/permissions";
import Checkbox from "@/components/Low/Checkbox";
import ReactDatePicker from "react-datepicker";
import clsx from "clsx";
import countryCodes from "country-codes-list";
import { User, Type as UserType } from "@/interfaces/user";
import { Type, UserImport } from "../../../interfaces/IUserImport";
import UserTable from "../../../components/UserTable";
import { EntityWithRoles } from "@/interfaces/entity";
import Select from "@/components/Low/Select";
import { IoInformationCircleOutline } from "react-icons/io5";
import { FaFileDownload } from "react-icons/fa";
import { HiOutlineDocumentText } from "react-icons/hi";

const EMAIL_REGEX = new RegExp(/^[a-zA-Z0-9]+(?:\.[a-zA-Z0-9]+)*@[a-zA-Z0-9]+(?:\.[a-zA-Z0-9]+)*$/);

const USER_TYPE_LABELS: { [key in Type]: string } = {
	student: "Student",
	teacher: "Teacher",
	corporate: "Corporate",
};

const USER_TYPE_PERMISSIONS: {
	[key in UserType]: { perm: PermissionType | undefined; list: UserType[] };
} = {
	student: {
		perm: "createCodeStudent",
		list: [],
	},
	teacher: {
		perm: "createCodeTeacher",
		list: [],
	},
	agent: {
		perm: "createCodeCountryManager",
		list: ["student", "teacher", "corporate", "mastercorporate"],
	},
	corporate: {
		perm: "createCodeCorporate",
		list: ["student", "teacher"],
	},
	mastercorporate: {
		perm: undefined,
		list: ["student", "teacher", "corporate"],
	},
	admin: {
		perm: "createCodeAdmin",
		list: ["student", "teacher", "agent", "corporate", "mastercorporate"],
	},
	developer: {
		perm: undefined,
		list: ["student", "teacher", "agent", "corporate", "admin", "developer", "mastercorporate"],
	},
};

interface Props {
	user: User;
	permissions: PermissionType[];
	entities?: EntityWithRoles[]
	onFinish: () => void;
}

export default function BatchCreateUser({ user, entities = [], permissions, onFinish }: Props) {
	const [infos, setInfos] = useState<UserImport[]>([]);

	const [duplicatedUsers, setDuplicatedUsers] = useState<UserImport[]>([]);
	const [newUsers, setNewUsers] = useState<UserImport[]>([]);

	const [isLoading, setIsLoading] = useState(false);
	const [expiryDate, setExpiryDate] = useState<Date | null>(
		user?.subscriptionExpirationDate ? moment(user.subscriptionExpirationDate).toDate() : null,
	);
	const [isExpiryDateEnabled, setIsExpiryDateEnabled] = useState(true);
	const [type, setType] = useState<Type>("student");
	const [showHelp, setShowHelp] = useState(false);
	const [entity, setEntity] = useState((entities || [])[0]?.id || undefined)

	const { openFilePicker, filesContent, clear } = useFilePicker({
		accept: ".xlsx",
		multiple: false,
		readAs: "ArrayBuffer",
	});

	useEffect(() => {
		if (!isExpiryDateEnabled) setExpiryDate(null);
	}, [isExpiryDateEnabled]);

	useEffect(() => {
		if (filesContent.length > 0) {
			const file = filesContent[0];
			readXlsxFile(file.content).then((rows) => {
				try {
					const information = uniqBy(
						rows
							.map((row) => {
								const [firstName, lastName, studentID, passport_id, email, phone, group, country] = row as string[];
								const countryItem =
									countryCodes.findOne("countryCode" as any, country.toUpperCase()) ||
									countryCodes.all().find((x) => x.countryNameEn.toLowerCase() === country.toLowerCase());

								return EMAIL_REGEX.test(email.toString().trim())
									? {
										email: email.toString().trim().toLowerCase(),
										name: `${firstName ?? ""} ${lastName ?? ""}`.trim(),
										type: type,
										passport_id: passport_id?.toString().trim() || undefined,
										groupName: group,
										studentID,
										entity,
										demographicInformation: {
											country: countryItem?.countryCode,
											passport_id: passport_id?.toString().trim() || undefined,
											phone: phone.toString(),
										},
									}
									: undefined;
							})
							.filter((x) => !!x) as typeof infos,
						(x) => x.email,
					);

					if (information.length === 0) {
						toast.error(
							"Please upload an Excel file containing user information, one per line! All already registered e-mails have also been ignored!",
						);
						return clear();
					}

					setInfos(information);
				} catch (e) {
					console.log(e)

					toast.error(
						"Please upload an Excel file containing user information, one per line! All already registered e-mails have also been ignored!",
					);
					return clear();
				}
			});
		}
		// eslint-disable-next-line react-hooks/exhaustive-deps
	}, [filesContent]);

	useEffect(() => {
		const crossReferenceEmails = async () => {
			try {
				const response = await axios.post("/api/users/controller?op=crossRefEmails", {
					emails: infos.map((x) => x.email)
				});

				const crossRefEmails = response.data;
				if (!!crossRefEmails) {
					const existingEmails = new Set(crossRefEmails.map((x: any) => x.email));
					const dupes = infos.filter(info => existingEmails.has(info.email));
					const newUsersList = infos.filter(info => !existingEmails.has(info.email));
					setNewUsers(newUsersList);
					setDuplicatedUsers(dupes);
				} else {
					setNewUsers(infos);
				}
			} catch (error) {
				toast.error("Something went wrong, please try again later!");
			}
		};

		if (infos.length > 0) {
			crossReferenceEmails();
		}
	}, [infos]);

	const makeUsers = async () => {
		const newUsersSentence = newUsers.length > 0 ? `create ${newUsers.length} user(s)` : undefined;
		const existingUsersSentence = duplicatedUsers.length > 0 ? `invite ${duplicatedUsers.length} registered student(s)` : undefined;

		if (!confirm(`You are about to ${[newUsersSentence, existingUsersSentence].filter((x) => !!x).join(" and ")}, are you sure you want to continue?`))
			return;

		/*Promise.all(duplicatedUsers.map(async (u) => await axios.post(`/api/invites`, {to: u.id, entity, from: user.id})))
			.then(() => toast.success(`Successfully invited ${duplicatedUsers.length} registered student(s)!`))
			.finally(() => {
				if (newUsers.length === 0) setIsLoading(false);
			});
		*/
		if (newUsers.length > 0) {
			setIsLoading(true);

			try {
				await axios.post("/api/batch_users", { users: newUsers.map((user) => ({ ...user, type, expiryDate })) });
				toast.success(`Successfully added ${newUsers.length} user(s)!`);
				onFinish();
			} catch (e) {
				console.error(e)
				toast.error("Something went wrong, please try again later!");
			} finally {
				setIsLoading(false);
				setInfos([]);
				clear();
			}
		} else {
			setIsLoading(false);
			setInfos([]);
			clear();
		}
	};


	const handleTemplateDownload = () => {
		const fileName = "UsersTemplate.xlsx";
		const url = `https://firebasestorage.googleapis.com/v0/b/encoach-staging.appspot.com/o/import_templates%2F${fileName}?alt=media&token=b771a535-bf95-4060-889c-a086df65d480`;

		const link = document.createElement('a');
		link.href = url;

		link.download = fileName;

		document.body.appendChild(link);
		link.click();
		document.body.removeChild(link);
	};

	return (
		<>
			<Modal isOpen={showHelp} onClose={() => setShowHelp(false)}>
				<>
					<div className="flex font-bold text-xl justify-center text-gray-700"><span>Excel File Format</span></div>
					<div className="mt-4 flex flex-col gap-4">
						<div className="flex flex-col gap-3 bg-gray-100 rounded-lg p-4">
							<div className="flex items-center gap-2">
								<HiOutlineDocumentText className={`w-5 h-5 text-mti-purple-light`} />
								<h2 className="text-lg font-semibold">
									The uploaded document must:
								</h2>
							</div>
							<ul className="flex flex-col pl-10 gap-2">
								<li className="text-gray-700 list-disc">
									be an Excel .xlsx document.
								</li>
								<li className="text-gray-700 list-disc">
									only have a single spreadsheet with only the following 8 columns in the <b>same order</b>:
									<div className="py-4 pr-4">
										<table className="w-full bg-white">
											<thead>
												<tr>
													<th className="border border-neutral-200 px-2 py-1">First Name</th>
													<th className="border border-neutral-200 px-2 py-1">Last Name</th>
													<th className="border border-neutral-200 px-2 py-1">Student ID</th>
													<th className="border border-neutral-200 px-2 py-1">Passport/National ID</th>
													<th className="border border-neutral-200 px-2 py-1">E-mail</th>
													<th className="border border-neutral-200 px-2 py-1">Phone Number</th>
													<th className="border border-neutral-200 px-2 py-1">Classroom Name</th>
													<th className="border border-neutral-200 px-2 py-1">Country</th>
												</tr>
											</thead>
										</table>
									</div>
								</li>
							</ul>
						</div>
						<div className="flex flex-col gap-3 bg-gray-100 rounded-lg p-4">
							<div className="flex items-center gap-2">
								<IoInformationCircleOutline className={`w-5 h-5 text-mti-purple-light`} />
								<h2 className="text-lg font-semibold">
									Note that:
								</h2>
							</div>
							<ul className="flex flex-col pl-10 gap-2">
								<li className="text-gray-700 list-disc">
									all incorrect e-mails will be ignored.
								</li>
								<li className="text-gray-700 list-disc">
									all already registered e-mails will be ignored.
								</li>
								<li className="text-gray-700 list-disc">
									the spreadsheet may have a header row with the format above, however, it is not necessary as long the columns are in the <b>right order</b>.
								</li>
								<li className="text-gray-700 list-disc">
									all of the e-mails in the file will receive an e-mail to join EnCoach with the role selected below.
								</li>
							</ul>
						</div>
						<div className="bg-gray-100 rounded-lg p-4">
							<p className="text-gray-600">
								{`The downloadable template is an example of a file that can be imported. Your document doesn't need to be a carbon copy of the template - it can have different styling but it must adhere to the previous requirements.`}
							</p>
						</div>
						<div className="w-full flex justify-between mt-6 gap-8">
							<Button color="purple" onClick={() => setShowHelp(false)} variant="outline" className="self-end w-full bg-white">
								Close
							</Button>

							<Button color="purple" onClick={handleTemplateDownload} variant="solid" className="self-end w-full">
								<div className="flex items-center gap-2">
									<FaFileDownload size={24} />
									Download Template
								</div>
							</Button>
						</div>
					</div>
				</>
			</Modal>
			<div className="border-mti-gray-platinum flex flex-col gap-4 rounded-xl border p-4">
				<div className="grid grid-cols-2 -md:grid-cols-1 gap-4">
					<div className="flex flex-col gap-4">
						<div className="flex items-end justify-between">
							<label className="text-mti-gray-dim text-base font-normal">Choose an Excel file</label>
							<button
								onClick={() => setShowHelp(true)}
								className="tooltip cursor-pointer p-1.5 hover:bg-gray-200 rounded-full transition-colors duration-200"
								data-tip="Excel File Format"
							>
								<IoInformationCircleOutline size={24} />
							</button>
						</div>
						<Button onClick={openFilePicker} isLoading={isLoading} disabled={isLoading}>
							{filesContent.length > 0 ? filesContent[0].name : "Choose a file"}
						</Button>
					</div>
					<div className={clsx("flex flex-col gap-4")}>
						<label className="font-normal text-base text-mti-gray-dim">Entity</label>
						<Select
							defaultValue={{ value: (entities || [])[0]?.id, label: (entities || [])[0]?.label }}
							options={entities.map((e) => ({ value: e.id, label: e.label }))}
							onChange={(e) => setEntity(e?.value || undefined)}
							isClearable={checkAccess(user, ["admin", "developer"])}
						/>
					</div>
				</div>
				{user && checkAccess(user, ["developer", "admin", "corporate", "mastercorporate"]) && (
					<>
						<div className="-md:flex-row -md:items-center flex justify-between gap-2 md:flex-col 2xl:flex-row 2xl:items-center">
							<label className="text-mti-gray-dim text-base font-normal">Expiry Date</label>
							<Checkbox isChecked={isExpiryDateEnabled} onChange={setIsExpiryDateEnabled} disabled={!!user.subscriptionExpirationDate}>
								Enabled
							</Checkbox>
						</div>
						{isExpiryDateEnabled && (
							<ReactDatePicker
								className={clsx(
									"flex min-h-[70px] w-full cursor-pointer justify-center rounded-full border p-6 text-sm font-normal focus:outline-none",
									"hover:border-mti-purple tooltip",
									"transition duration-300 ease-in-out",
								)}
								filterDate={(date) =>
									moment(date).isAfter(new Date()) &&
									(user.subscriptionExpirationDate ? moment(date).isBefore(user.subscriptionExpirationDate) : true)
								}
								dateFormat="dd/MM/yyyy"
								selected={expiryDate}
								onChange={(date) => setExpiryDate(date)}
							/>
						)}
					</>
				)}
				<label className="text-mti-gray-dim text-base font-normal">Select the type of user they should be</label>
				{user && (
					<select
						defaultValue="student"
						onChange={(e) => setType(e.target.value as Type)}
						className="flex min-h-[70px] w-full min-w-[350px] cursor-pointer justify-center rounded-full border bg-white p-6 text-sm font-normal focus:outline-none">
						{Object.keys(USER_TYPE_LABELS)
							.filter((x) => {
								const { list, perm } = USER_TYPE_PERMISSIONS[x as Type];
								// if (x === "corporate") console.log(list, perm, checkAccess(user, list, permissions, perm));
								return checkAccess(user, getTypesOfUser(list), permissions, perm);
							})
							.map((type) => (
								<option key={type} value={type}>
									{USER_TYPE_LABELS[type as keyof typeof USER_TYPE_LABELS]}
								</option>
							))}
					</select>
				)}
				{newUsers.length !== 0 && (
					<div className="flex w-full flex-col gap-4">
						<span className="text-mti-gray-dim text-base font-normal">New Users:</span>
						<UserTable users={newUsers} />
					</div>
				)}
				{duplicatedUsers.length !== 0 && (
					<div className="flex w-full flex-col gap-4">
						<span className="text-mti-gray-dim text-base font-normal">Duplicated Users:</span>
						<UserTable users={duplicatedUsers} />
					</div>
				)}
				<Button className="my-auto mt-4" onClick={makeUsers} disabled={newUsers.length === 0}>
					Create {newUsers.length !== 0 ? `${newUsers.length} New Users` : ''}
				</Button>
			</div>
		</>
	);
}
